package geniusweb.profileconnection;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;

import com.fasterxml.jackson.databind.ObjectMapper;

import geniusweb.profile.Profile;
import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;

/**
 * ProfileInterface based on a plain filesystem UTF8 file.
 */
public class FileProfileConnector implements ProfileInterface {
	private final static ObjectMapper jackson = new ObjectMapper();
	private final LinearAdditiveUtilitySpace profile;

	/**
	 * 
	 * @param filename the filename of the file containing the profile
	 * @throws IOException if the profile is not proper json
	 */
	public FileProfileConnector(String filename) throws IOException {
		Path path = new File(filename).toPath();
		String serialized = new String(Files.readAllBytes(path),
				StandardCharsets.UTF_8);
		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
				Profile.class);
	}

	@Override
	public LinearAdditiveUtilitySpace getProfile() {
		return profile;
	}

}
